IMPORT TIME
IMPORT CONCURRENT.FUTURES

# SCRIPT PARAMS
MULTIPROCESSING = TRUE
# MULTIPROCESSING = FALSE
IF MULTIPROCESSING:
    N_WORKER = 4
ELSE:
    N_WORKER = 1


# SANTA'S PLAN
SANTA_LIST = RANGE(7) # 7*10**9 # MIT WENIGER 7 ZAHLEN, SHOW ORDNUNG MESS UP
N = LEN(SANTA_LIST) // N_WORKER
TOTAL_LEN = 0


DEF MAGIC(GIFT_LIST, WHICH):
    FOR ITEM IN GIFT_LIST:
        PRINT(ITEM, WHICH)
        ITEM **= 2
    RETURN WHICH


T1 = TIME.TIME()

EXECUTORTYPE = CONCURRENT.FUTURES.PROCESSPOOLEXECUTOR
WITH EXECUTORTYPE() AS EXECUTOR:
    JOBS = []
    FOR I IN RANGE(N_WORKER):
        IF I < N_WORKER - 1:
            SUB_LIST = SANTA_LIST[I * N:(I + 1) * N]
        ELSE:
            SUB_LIST = SANTA_LIST[I * N:]

        # TRACK LENGTH OF SUBLISTS TO CHECK IF THE SPLITTING WAS SUCCESSFUL
        TOTAL_LEN += LEN(SUB_LIST)

        JOBS.APPEND(EXECUTOR.SUBMIT(MAGIC, SUB_LIST, I))
    FOR JOB IN CONCURRENT.FUTURES.AS_COMPLETED(JOBS):
        RES = JOB.RESULT()
        PRINT(RES)

ASSERT TOTAL_LEN == LEN(SANTA_LIST)

PRINT("ELAPSED TIME", TIME.TIME() - T1, "MULTIPROCESSING:", MULTIPROCESSING) 