import concurrent.futures
import time

# script params
n_worker = 4

f = open("multip.py", "r")
content = f.readlines()
n = len(content) // n_worker


def process(list_of_lines):
    """ Does something item-wise to list_of_lines. """
    for i in range(0, 1000):
        for item in list_of_lines:
            item = item.lower()
    return list_of_lines


t1 = time.time()

ExecutorType = concurrent.futures.ProcessPoolExecutor
with ExecutorType() as executor:
    jobs = []
    for i in range(n):
        if i < n_worker - 1:
            sub_list = content[i * n:(i + 1) * n]
        else:
            sub_list = content[i * n:]

        jobs.append(executor.submit(process(sub_list)))
    for job in concurrent.futures.as_completed(jobs):
        res = job.result()
        print(res)

print("Elapsed time (with multiprocessing)", t1 - time.time())
