# module creates one combined alphabet to avoid repeating letters

langlist = ["ru", "pl", "uk", "sl", "sk", "sr", "bg", "be", "mk", "cs", "szl", "cu", "dsb", "rue"]

#iterate over list of languages and create combined alphabet of all languages
combined_letterlist = []
for lang in langlist:
    #extract letters from alphabets
    #hardcode local path
    localpath = "C:\\Users\\samed\\Documents\\Heidelberg\\Computerlinguistik\\Exp-ML\\exp-ml-1\\project\\alphabets\\"
    filename = localpath + lang + "_alphabet.txt"

    with open(filename, "r", encoding="utf-8") as f:
        letterlist = f.read().split(",")
        for letter in letterlist:
            if letter not in combined_letterlist:
                combined_letterlist.append(letter)

#write alphabet into new file
with open(localpath + "combined_alphabet.txt", "w+", encoding="utf-8") as f:
    i = 0
    for letter in combined_letterlist:
        #if last letter then no comma
        if i < len(combined_letterlist) - 1:
            f.write(letter + ",")
        else:
            f.write(letter)
        i += 1
